
select * from dbo.DiaryEnter
SELECT ID,CreateTime,IncomeOrExpense,Money,Category,Introduce,Balance
FROM DiaryEnter ORDER BY ID ASC

INSERT INTO DiaryEnter(CreateTime,IncomeOrExpense,Money,Category,Introduce,Balance)
VALUES('','','','','','')
go

Create PROC usp_diaryenter_select
as
SELECT [ID], [CreateTime],[IncomeOrExpense],[Money],[Category],[Introduce],[Balance] FROM DiaryEnter 
go

--
Create PROC usp_diaryenter_insert
 @createTime DATETIME,
 @incomeOrExpense VARCHAR(10),
 @money DECIMAL(18,2),
 @category VARCHAR(50),
 @introduce VARCHAR(50),
 @balance DECIMAL(18,2)
as
INSERT INTO [DiaryEnter]([CreateTime],[IncomeOrExpense],[Money],[Category],[Introduce],[Balance]) 
VALUES(@createTime,@incomeOrExpense,@money,@category,@introduce,@balance)
go

--
Create PROC usp_diaryenter_update
 @id INT,
 @incomeOrExpense VARCHAR(10),
 @money DECIMAL(18,2),
 @category VARCHAR(50),
 @introduce VARCHAR(50),
 @balance DECIMAL(18,2)
as
UPDATE DiaryEnter  set [IncomeOrExpense]=@incomeOrExpense,[Category]=@category,[Money]=@money,[Introduce]=@introduce,[Balance]=@balance where [ID]=@id
go

