using System;
using System.Collections.Generic;
using System.Text;
using Heb.DAL;
using Heb.Model;
namespace Heb.BLL
{
    /// <summary>
    /// ռ¼ ߼
    /// </summary>
    public class DiaryEnterManager
    {
        //ȫ  ⼸ֵ,治ֹһõ
        DiaryEnter waitOperateDiary;//ȴռ
        decimal money;//õǮ
        decimal balance ;//õǮ
        string incomeOrExpense;// /֧
        decimal middleMoney = 0;//мĲ,ʼֵΪ0ֵ


        DiaryEnterService diaryService = new DiaryEnterService();

        /// <summary>
        ///   ؽɹʧ
        /// </summary>
        /// <param name="CreateTime">ʱ</param>
        /// <param name="IncomeOrExpense">/֧</param>
        /// <param name="Money"></param>
        /// <param name="Category"></param>
        /// <param name="Introduce">˵</param>
        /// <param name="endMoney">ĩ(ڼ)</param>
        /// <returns>bool</returns>
        public bool InsertDiaryEnter(DateTime CreateTime, string IncomeOrExpense, decimal Money, string Category, string Introduce, decimal endMoney)
        {
            //ݲ,ݴ ôɹ ߲ʧ
            if (IncomeOrExpense=="")
            {
                //ĩ
                endMoney += Money;
            }
            else
            {
                //֧Ǯ,ĩ
                endMoney -= Money;
            }


            return diaryService.InsertDiaryEnter(CreateTime, IncomeOrExpense, Money, Category, Introduce, endMoney) > 0;
        }
         /// <summary>
       /// ѯеռ ռ¼ļ
       /// </summary>
       /// <returns>List<DiaryEnter></returns>
        public List<DiaryEnter> getAllDiaryEnter()
        {
           return diaryService.getAllDiaryEnter();
        }

        /// <summary>
        /// ID ѯһϢ
        /// </summary>
        /// <param name="Id"></param>
        /// <returns></returns>
        public DiaryEnter getDiaryEnterById(int Id)
        {
            List<DiaryEnter> list = diaryService.getAllDiaryEnter();
            DiaryEnter diary = new DiaryEnter();
            foreach (DiaryEnter item in list)
            {
                if (item._ID==Id)
                {
                    diary = item;
                    
                }
            }
            return diary;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public bool DeleteDiaryEnterById(int id)
        {
            //ɾ, һɾһ,಻޸
          
          
            //õ Id  ,еĶҪı
             waitOperateDiary = getDiaryEnterById(id);
             money = waitOperateDiary._Money;//õǮ
             balance = waitOperateDiary._Balance;//õǮ
             incomeOrExpense = waitOperateDiary._IncomeOrExpense;// /֧
           if (incomeOrExpense == "")
           {
               middleMoney =-money ;//ӵĲ
           }
           else
           {
               //֧
               middleMoney = money;//ٵĲ
           }

           diaryService.DeleteDiaryEnterById(id);//Ժ,ɾ
           //Ȼ,...ΰѺۼƸ
            //õ ID ID


           return UpdateBecauseChange(id);

        }

        /// <summary>
        /// Ϊ ֵı Щֵı
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        private bool UpdateBecauseChange(int id)
        {
            List<DiaryEnter> list = diaryService.getDiaryLThanId(id);
            if (list == null)
            {
                return true;//һ¼,治ô
            }
            else
            {
                // װһĶ
                int result = 0;
                foreach (DiaryEnter diary in list)
                {
                    //ǮĲ,Ѿת Ĵ
                    result += diaryService.updateMoneyToCount(diary._ID, diary._Balance + middleMoney);
                }

                return result == list.Count ? true : false;
            }
        }

       
        /// <summary>
       /// õݵһĩ
       /// </summary>
       /// <param name="id"></param>
       /// <returns></returns>
        public decimal EndMoney(int id)
        {
            return diaryService.EndMoney(id);
        }

        public decimal EndMoney()
        {
            return diaryService.EndMoney();
        }
         /// <summary>
       /// ID,޸
       /// </summary>
       /// <param name="Id">ID</param>
        /// <param name="IOEAfter"> ݹ /֧ IncomeOrExpenseAfter ļд</param>
       /// <param name="Money">Ǯ</param>
       /// <param name="Category"></param>
       /// <param name="Introduce">˵</param>
       /// <param name="Balance"></param>
       /// <returns></returns>
        public bool UpdateDiaryEnterById(int Id, string IOEAfter, decimal Money, string Category, string Introduce)
        {
            //߼ ǮҪһ
            DiaryEnter dia = getDiaryEnterById(Id);

            if (dia._IncomeOrExpense == IOEAfter && dia._Money == Money)
            {
                //û޸ Ǯ Լ֧ ô¼
                return diaryService.UpdateDiaryEnterById(Id, IOEAfter, Money, Category, Introduce, dia._Balance) > 0;
            }
            else
            {
                 //˲ ,˽   ݵĩֵ,Ҫ¸Ա

                 //ݵIDе,ɾ
                 waitOperateDiary = getDiaryEnterById(Id);
                 money = waitOperateDiary._Money;//õǰǮ
                 balance = waitOperateDiary._Balance;//ԭõǮ
                 string incomeOrExpense = waitOperateDiary._IncomeOrExpense;// ԭ /֧
                 if (incomeOrExpense == "" && IOEAfter == "")
                {
                    middleMoney = Money - money;
                }
                else if (incomeOrExpense == "֧" && IOEAfter == "֧")
	            {
                    middleMoney = money - Money;
	            }
                else if (incomeOrExpense==""&&IOEAfter=="֧")
                {
                    
                   middleMoney = -(money + Money);//Ǯ
                }
                else
                {
                    //incomeOrExpense=="֧"&&IOEAfter==""
                    middleMoney = money + Money;//Ǯ

                }

                 // Ըµǰ
                diaryService.UpdateDiaryEnterById(Id, IOEAfter, Money, Category, Introduce, balance + middleMoney);

                 // ĸıʵǸ
                return UpdateBecauseChange(Id);
            }
            
        }


     
    }
}
