﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Heb.BLL;
using Heb.Model;
using System.Collections.Generic;

public partial class _Default : System.Web.UI.Page
{
    DiaryEnterManager diaryManager = new DiaryEnterManager();//业务逻辑层的 类,处理数据的
    protected void Page_Load(object sender, EventArgs e)
    {
        ChangeEndMoney();
        Bond();
    }
    /// <summary>
    /// 执行删除任务 ajax发请求 id
    /// </summary>
    public void Bond()
    {
        bool result = false;
        //删除数据 
        if (Request.Form["id"]!=null)
        {
            int id = Convert.ToInt32(Request.Form["id"]);
            result= diaryManager.DeleteDiaryEnterById(id);
            if (result)
            {
                ChangeEndMoney();
            }
        }

        //更新数据
        if (Request.Form["data"]!=null)
        {
            string a = Request.Form["data"].ToString();
            List<DiaryEnter> list = new DiaryEnterJson().Json2DiaryEnterList(a);
            DiaryEnter dia;
            if (list.Count>1)
            {
                dia = list[list.Count - 1];//得到最后一个
             }
             else
             {
                 dia = list[0];
             }

            //期末余额
            decimal money = Convert.ToDecimal(this.endMoney.InnerText);
            if (dia._ID==0)
            {
                // ID为0,表示插入数据 传递这个对象 然后到逻辑层处理
                
               result=diaryManager.InsertDiaryEnter(dia._CreateTime, dia._IncomeOrExpense, dia._Money, dia._Category, dia._Introduce, money);
               if (result)
               {
                   ChangeEndMoney();
               }
            }
            else
            {
                //修改数据数据,修改一条,很多地方都要重新修改啊

                //它上面的,的紧挨着的一条数据的钱的余额 就是 它的 末期余额 要用来计算的
                //得到一个 decimal类型的数据

                //下面是用来修改 没有改变金额 钱的情况下的 .仅用来做测试方法
              result = diaryManager.UpdateDiaryEnterById(dia._ID, dia._IncomeOrExpense, dia._Money, dia._Category, dia._Introduce);
              if (result)
              {
                  ChangeEndMoney();
              }
            }
        }
    }

    public void Bind()
    {
         ChangeEndMoney();
    }
   
    /// <summary>
    /// 更新期末余额
    /// </summary>
    public void ChangeEndMoney()
    {
        //得到数据库里面 的期末余额
        if (diaryManager.EndMoney()>0)
        {
            this.endMoney.InnerText = diaryManager.EndMoney().ToString();
        }
        else
        {
            this.endMoney.InnerText = "10000";
            
        }
        
    }

}
